unit PythonIDE_bas;

interface

procedure readConfiguration;

procedure saveConfiguration;


function readRegBoolean(szMain, szItem:string; bDefault:boolean):Boolean;

function readRegString(szMain, szItem, szdefault:String):string;

function readRegInteger(szMain, szItem:string; Idefault:integer):Integer;

procedure writeRegBoolean(Cregistry,szItem:string; value:Boolean);

procedure writeRegInteger(CRegistry,szItem:string; value:integer);

procedure writeRegString(CRegistry, szItem:string; value:String);

procedure Msgbox(szTitel,szText:string);

procedure Errorbox(szTitel,szText:string);


Function ReadString (szText, szTitel, szVorgabe:String):String;

 function  IVal(text:string; var zahl:integer):boolean;


procedure fsplit (szGesamt:string; var szPfad, szDatei, szExt:string);

function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;

function getComspec:string;


Const NL = chr(13)+chr(10);


var G_Path:string;

implementation


uses Registry,
     Main,
     WinTypes,
     SysUtils,
     forms,
     shellAPI,
     Dialogs ,
     PythonIDE_var;

procedure readConfiguration;
var szAktPfad:string;
begin
  getDir(0,szAktPfad);
     //G_InEditMitTabs := ReadRegBoolean(C_REG_ADR,'Editor_InEditMitTabs', false);

     G_CaptionMitVollemNamen := ReadRegBoolean(C_REG_ADR,'Editor_CaptionMitVollemNamen', true);

     G_TabWidth :=  ReadRegInteger(C_REG_ADR,'Allgemein_TabBreite', 5);


     G_SucheAmAktuellenCursor:= ReadRegBoolean(C_REG_ADR,'Allgemein_SucheAmAktuellenCursor',false);


end; (* lese konfig *)




procedure saveConfiguration;
begin
     WriteRegBoolean(C_REG_ADR,'Editor_CaptionMitVollemNamen', G_CaptionMitVollemNamen);


     WriteRegString(C_REG_ADR,'Pfade_EditorPfad',G_EditorPath);

     WriteRegBoolean(C_REG_ADR,'Allgemein_SucheAmAktuellenCursor', G_SucheAmAktuellenCursor);

     WriteRegInteger(C_REG_ADR,'Allgemein_TabBreite', G_TabWidth);


     WriteRegInteger(C_REG_ADR,'Fenster_Top', FMain.Top);
     WriteRegInteger(C_REG_ADR,'Fenster_Left', FMain.Left);
     WriteRegInteger(C_REG_ADR,'Fenster_Width', FMain.Width);
     WriteRegInteger(C_REG_ADR,'Fenster_Height', FMain.Height);

end; (* schreibe konfig *)




       function readRegBoolean(szMain, szItem:string; bDefault:boolean):Boolean;
       var skey:string;
           res:boolean;
           regist:TRegistry;
       begin
          regist:=TRegistry.Create;
          regist.Rootkey := HKEY_CURRENT_USER;
          skey := szMain ;
          try
            if regist.Openkey(sKey,false)
            then res := regist.ReadBool(szItem)
            else res := BDefault;
          except
            res := bDefault;
          end;
          regist.Closekey;
          result := res;
          regist.free;
       end;


       function readRegString(szMain, szItem, szdefault:String):string;
       var res:string;
           skey:string;
          regist:TRegistry;
       begin
          regist:=TRegistry.Create;
          regist.Rootkey := HKEY_CURRENT_USER;
          skey := szMain ;
          try
            if regist.Openkey(sKey,false)
            then res := regist.ReadString(szItem)
            else res := szdefault;
          except
            res := szdefault;
          end;
          regist.Closekey;
          result := res;
          regist.free;
       end;


       function readRegInteger(szMain, szItem:string; Idefault:integer):Integer;
       var skey:string;
           res:integer;
           regist:TRegistry;
       begin
          regist:=TRegistry.Create;
          regist.Rootkey := HKEY_CURRENT_USER;
          skey := szMain;
          try
            if regist.Openkey(sKey,false)
            then res := regist.ReadInteger(szItem)
            else res := IDefault;
          except
            res := IDefault;
          end;
          regist.Closekey;
          result := res;
          regist.free;
       end;


    procedure writeRegBoolean(Cregistry,szItem:string; value:Boolean);
    var skey:string;
           regist:TRegistry;
    begin
      regist:=TRegistry.Create;
      regist.Rootkey := HKEY_CURRENT_USER;
      skey := Cregistry;
      if regist.Openkey(sKey,true) then
      begin
        regist.writeBool(szItem,value);
      end;
      regist.closekey;
      regist.free;
    end;

    procedure writeRegInteger(CRegistry,szItem:string; value:integer);
    var skey:string;
           regist:TRegistry;
    begin
       // CurrentUser  / Software
      regist:=TRegistry.Create;
      regist.Rootkey := HKEY_CURRENT_USER;
      skey := CRegistry;
      if regist.Openkey(sKey,true) then
      begin
        regist.writeInteger(szItem,value);
      end;
      regist.closekey;
      regist.free;
    end;

    procedure writeRegString(CRegistry, szItem:string; value:String);
    var skey:string;
           regist:TRegistry;
    begin
      regist:=TRegistry.Create;
      regist.Rootkey := HKEY_CURRENT_USER;
      skey := CRegistry;
      regist.Openkey(sKey,true);
      if regist.Openkey(sKey,true) then
      begin
        regist.writeString(szItem,value);
      end;
      regist.closekey;
      regist.free;
    end;
    

procedure Msgbox(szTitel,szText:string);
begin
   // uses WinProcs
  Application.MessageBox(PChar(szText),PChar(szTitel), MB_iconExclamation+mb_OK);
end;

procedure Errorbox(szTitel,szText:string);
begin
  // WinTypes
  Application.MessageBox(PChar(szText),PChar(szTitel), MB_IconStop+mb_OK);
end;



Function ReadString (szText, szTitel, szVorgabe:String):String;
var szZeile:string;
begin
  szZeile:=szVorgabe;
  if (InputQuery(szTitel,szText,szZeile))  // Dialogs
  then result:=szZeile
  else result:='';
end;


 function  IVal(text:string; var zahl:integer):boolean;
 var i:Integer;
     Zahl1:longint;
     d:double;
 begin
   text:=trim(Text);
   if text = '' then
   begin
     result := false;
     exit;
   end;
   i:=0;
   val(text,d,i);
   if (i=0) and (d <=2147483647.0) and (d > -2147483648.0) then
   begin
     i:=0;
     val(text,zahl1,i);
     IVal:=TRUE;
     Zahl:=Zahl1;
   end
   else
   begin
     IVal:=FALSE;
     Zahl:=0;
   end;
 end; (* IVAL *)
 
procedure fsplit (szGesamt:string; var szPfad, szDatei, szExt:string);
var n1, n2:integer;
    szZeile:string;
begin
   (*  ChangeFileExt(szdatei,'.ERG');  *)
  szPfad:=ExtractFilePath(szGesamt);
  szZeile:=ExtractFileName(szGesamt);
  szExt := ExtractFileExt(szGesamt);  // mit .EXE
  // ChangeFileExt
  //  ps^ := ChangeFileExt(szZ,'.DBF');

  if szExt = '' then
  begin
    szDatei:=szZeile;
  end
  else
  begin
   n1 := length(szZeile);
   n2 := length(szExt);
   szDatei:=copy(szZeile,1,n1-n2);
  end;
End; (* fsplit *)

// SW_SHOW
function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;
// var  zFileName, zParams: array[0..279] of Char;
var szExt:string;
begin
  Result := ShellExecute(Application.MainForm.Handle, 'open',
    PChar(FileName), PChar(Params),
    PChar(DefaultDir), ShowCmd);
  if Result<=32 then
  begin
    case Result of
      0: Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Zu wenig Speicher');
      ERROR_FILE_NOT_FOUND:
        begin
          szExt := Uppercase(ExtractFileExt(Filename));
          if (szExt='.EXE') or (szExt='.COM') then
          Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Das Programm existiert nicht');
        end;
      SE_ERR_NOASSOC:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Fr diese Datei existiert keine Verknpfung');

      ERROR_PATH_NOT_FOUND:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Der Pfad wurde nicht gefunden');
      ERROR_BAD_FORMAT:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Das Programm ist fehlerhaft');
      SE_ERR_ACCESSDENIED:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Auf das Programm konnte nicht zugegriffen werden. Zugriffsverweigerung');
      SE_ERR_ASSOCINCOMPLETE:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Die Dateizuordnung ist fehlerhaft oder nicht vorhanden');
      SE_ERR_DDEFAIL,
      SE_ERR_DDETIMEOUT,
      SE_ERR_DDEBUSY:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'DDE Fehler');
      SE_ERR_DLLNOTFOUND:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Die DLL konnte nicht gefunden werden');
      SE_ERR_OOM:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Zu wenig Speicher');
      SE_ERR_SHARE:
        Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Zugriff verweigert. A sharing violation occurred.');
     else  Errorbox('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName);
    end;
  end;
end;

function getComspec:string;
begin
   result := SysUtils.getenvironmentVariable( 'COMSPEC' );
end;


begin
 G_Path :=  ExtractFilepath(Application.ExeName);
end.
