# coding=utf8

import tkinter
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both")
		self.config(background = "yellow") 
		self.setGUI()

	def setGUI(self):		
		self.inputui = tkinter.Entry(self)
		self.inputui.pack(fill="both", padx="5",pady="5")

		self.var_name = tkinter.StringVar()
		self.var_name.set("Ihr Name...")
		self.inputui["textvariable"] = self.var_name


		self.bnEsc = tkinter.Button(self)
		self.bnEsc["text"] = "Beenden"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(padx="10",pady="10", side="right")

		self.bnRev = tkinter.Button(self)
		self.bnRev["text"] = "Umdrehen"
		self.bnRev["command"] = self.onReverse
		self.bnRev.pack(padx="10",pady="10", side="right")

	def onReverse(self):
		self.var_name.set( self.var_name.get()[::-1] )
		messagebox.showinfo( "Hello Python", "Hello World")



root = tkinter.Tk()
root.title("Doku_ui3.py")
root.geometry("250x100")
app = MyApp(root)
app.mainloop()


