# coding=utf8

import tkinter
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both")  # dialog zoomt
		self.setGUI()

	def setGUI(self):	
		# pack ist wie das DockPanel in WPF
		# erst muessen die "normalen" UI-Elemente eintgetragen werden
		# am Schluss werden die UI-Elemente eingetragen, die fill="both" haben

		inputframe = tkinter.Frame(self) # „JPanel“ fuer die Eingabe
		inputframe.config(background = "red") #"#FF0000"
		inputframe.pack(fill="x", side="top" ) # ohne expand, da fill=“x“

		self.label1 = tkinter.Label(inputframe, fg="blue", bg="#FFFF00")
		self.label1["text"] = "Eingabe"
		self.label1.pack(side="left")
	
		self.inputui = tkinter.Entry(inputframe)
		self.inputui.pack(expand=True,fill="x",padx="5",pady="5")
		

		self.var_name = tkinter.StringVar()
		self.var_name.set("Ihr Name...")
		self.inputui["textvariable"] = self.var_name


		buttonframe = tkinter.Frame(self)  # „JPanel“ fuer die Eingabe
		buttonframe.config(background = "blue") #"#FF0000"
			# ohne expand, da fill=“x“
		buttonframe.pack(fill="x", side="bottom" )


		self.bnEsc = tkinter.Button(buttonframe)
		self.bnEsc["text"] = "Beenden"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(padx="5", side="right")

		self.bnAction = tkinter.Button(buttonframe)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.onAction
		self.bnAction.pack(side="right")
		self.bnAction.config(foreground= "green")

	def onAction(self):
		str = self.var_name.get()
		messagebox.showinfo( "Hello Python", str)
		self.editor.insert("end",str+"\r\n")

root = tkinter.Tk()
root.title("Entry")
root.geometry("200x100")
app = MyApp(root)
app.mainloop()

