
import tkinter
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack()
		self.setGUI()

	def setGUI(self):		
		self.inputui = tkinter.Entry(self)
		self.inputui.pack(expand=True, fill="x", padx="30",pady="10")


		self.bnOk = tkinter.Button(self)
		self.bnOk["text"] = "Abbruch"
		self.bnOk["command"] = self.quit
		self.bnOk.pack(padx="10",pady="10", side="right")

		self.bnInfo = tkinter.Button(self)
		self.bnInfo["text"] = "ShowInfo"
		self.bnInfo["command"] = self.onshowinfo
		self.bnInfo.pack(padx="10",pady="10", side="right")

		self.bnWarning = tkinter.Button(self)
		self.bnWarning["text"] = "ShowWarning"
		self.bnWarning["command"] = self.onshowwarning
		self.bnWarning.pack(padx="10",pady="10", side="right")

		self.bnError = tkinter.Button(self)
		self.bnError["text"] = "ShowError"
		self.bnError["command"] = self.onshowerror
		self.bnError.pack(padx="10",pady="10", side="right")

	def onshowinfo(self):
		# error warning info question     default='yes'
		messagebox.showinfo( "Meldung", "Ihre Festplatte wird formatiert",icon='info')

	def onshowwarning(self):
		messagebox.showwarning( "Hello Python", "Hello World")

	def onshowerror(self):
		messagebox.showerror( "Hello Python", "Hello World")


root = tkinter.Tk()
root.title("Mein Fenster")
# root.geometry("200x100")
app = MyApp(root)
app.mainloop()