
import tkinter

class MyApp(tkinter.Frame):

  def __init__(self, master=None):
    tkinter.Frame.__init__(self, master)
    self.pack()
    self.setGUI()

  def setGUI(self):
    self.inputui = tkinter.Entry(self)
    self.inputui.pack()

    self.propertyInputui = tkinter.StringVar()
    self.propertyInputui.set("Ihr Name...")
    self.inputui["textvariable"] = self.propertyInputui

    self.bnOk = tkinter.Button(self)
    self.bnOk["text"] = "Ok"
    self.bnOk["command"] = self.quit
    self.bnOk.pack(side="right")

    self.bnRev = tkinter.Button(self)
    self.bnRev["text"] = "Umdrehen"
    self.bnRev["command"] = self.onReverse
    self.bnRev.pack(side="right")

  def onReverse(self):
    self.propertyInputui.set( self.propertyInputui.get()[::-1] )

# app = MyApp( tkinter.Tk() )
# app.mainloop()

MyApp().mainloop()