import tkinter

class MyApp(tkinter.Frame):
	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack()
		self.createWidgets()
		self.createBindings()
        
	def createWidgets(self):
		self.label = tkinter.Label(self)
		self.label.pack()
		self.label["text"] = "Bitte in das Textfeld klicken oder am Rad drehen"
       
		self.entry = tkinter.Entry(self)
		self.entry.pack()
        
		self.ok = tkinter.Button(self)
		self.ok.pack()
		self.ok["text"] = "Beenden"
		self.ok["command"] = self.quit
        
	def createBindings(self):
		self.entry.bind("42", self.event42)
		self.entry.bind("<ButtonPress-1>", self.eventMouseClick)
		self.entry.bind("<MouseWheel>", self.eventMouseWheel)

	def event42(self, event):
		self.label["text"] = "Sie kennen das geheime Passwort!"

	def eventMouseClick(self, event):
		self.label["text"] = "Mausklick an Position ({},{})".format(event.x, event.y)

	def eventMouseWheel(self, event):
		self.label["text"] = "Mausrad ({})".format(event.delta)

root = tkinter.Tk()
root.title("Mouse Events")
root.geometry("300x100")
app = MyApp(root)
app.mainloop()