unit Start;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, jpeg;


const C_Version = 'Version 3.2, Build 125,  03. Juli 2016';

type
  TFStart = class(TForm)
    BnWeiter: TButton;
    LHead: TLabel;
    LWilhelm: TLabel;
    Timer1: TTimer;
    LVersion: TLabel;
    LFreeWare: TLabel;
    LWWW: TLabel;
    LEmail: TLabel;
    LDozent: TLabel;
    LCopyright: TLabel;
    LFBAI: TLabel;
    Label1: TLabel;
    procedure BnWeiterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Init;
    procedure LWWWClick(Sender: TObject);
    procedure LEmailClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FStart: TFStart;

implementation

{$R *.DFM}

uses PythonIDE_bas;


procedure TFStart.FormCreate(Sender: TObject);
begin
  LVersion.Caption :=C_Version;
end;

procedure TFStart.Init;
var w:integer;
begin
  Caption := 'Info zum Programm';
  Timer1.enabled := false;
  BnWeiter.visible := true;

  w := width;

  LHead.Left := (w-LHead.Width) shr 1;
  LFreeWare.Left := (w-LFreeWare.Width) shr 1;
  LVersion.Left := (w-LVersion.Width) shr 1;
  LCopyright.Left := (w-LCopyright.Width) shr 1;
  LWilhelm.Left := (w-LWilhelm.Width) shr 1;
  LDozent.Left := (w-LDozent.Width) shr 1;
  LFBAI.Left := (w-LFBAI.Width) shr 1;
  Lwww.Left := (w-Lwww.Width) shr 1;
  Lemail.Left := (w-Lemail.Width) shr 1;

  ShowModal;
end;

procedure TFStart.BnWeiterClick(Sender: TObject);
begin
  close;
end;


procedure TFStart.Timer1Timer(Sender: TObject);
begin
  Timer1.enabled := false;
  BnWeiter.visible := true;
end;


procedure TFStart.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := BnWeiter.visible;
end;





procedure TFStart.LWWWClick(Sender: TObject);
begin
  ExecuteFile('http://www.miwilhelm.de/','','', SW_SHOW);
end;

procedure TFStart.LEmailClick(Sender: TObject);
begin
  ExecuteFile('mailto:mwilhelm@hs-harz.de','','', SW_SHOW);
end;

end.

