# coding=utf8

import tkinter
from tkinter import messagebox

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.config(background = "yellow") 
		self.pack(expand=True, fill="both")
		#self.pack(expand=True)
		#self.pack(fill="both")
		self.setGUI()

	def setGUI(self):	

		inputframe = tkinter.Frame(self)
		inputframe.background = "red" #"#FF0000"
		inputframe.pack(expand=True,fill="x", side="top" )

		self.label1 = tkinter.Label(inputframe)
		self.label1["text"] = "Eingabe"
		self.label1.config(foreground = "blue" )
		self.label1.config(background = "#FFFF00") #"#FF0000"
		self.label1.pack(side="left")
	
		self.inputui = tkinter.Entry(inputframe)
		self.inputui.pack(expand=True,fill="x",padx="5",pady="5")
		#self.inputui.pack(padx="5",pady="5")

		self.var_name = tkinter.StringVar()
		self.var_name.set("Ihr Name...")
		self.inputui["textvariable"] = self.var_name

		buttonframe = tkinter.Frame(self)
		buttonframe.pack(expand=True,fill="x", side="top" )

		self.bnEsc = tkinter.Button(buttonframe)
		self.bnEsc["text"] = "Beenden"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(padx="5", side="right")

		self.bnRev = tkinter.Button(buttonframe)
		self.bnRev["text"] = "Umdrehen"
		self.bnRev["command"] = self.onReverse
		self.bnRev.pack(side="right")

	def onReverse(self):
		self.var_name.set( self.var_name.get()[::-1] )
		messagebox.showinfo( "Hello Python", "Hello World")



root = tkinter.Tk()
root.title("Doku_ui5.py")
root.geometry("250x100")
app = MyApp(root)
app.mainloop()


