unit EinstProg;

interface

{$G+}




uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, TabNotBk, StdCtrls, Buttons, Spin, ComCtrls, Grids,
  OroGrid, Menus, ExtCtrls;

type
  TFEinstProg = class(TForm)
    BnOkay: TButton;
    BnAbbruch: TButton;
    BnHilfe: TButton;
    BnLinkerSearch: TButton;
    BnCompilerSearch: TButton;
    ECompiler: TEdit;
    ECompilerParameter: TEdit;
    Label5: TLabel;
    Label3: TLabel;
    Panel8: TPanel;
    Label12: TLabel;
    ERun: TEdit;
    ERunParameter: TEdit;
    Label13: TLabel;
    Panel9: TPanel;
    OpenDialog1: TOpenDialog;
    procedure BnOkayClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BnAbbruchClick(Sender: TObject);
    procedure Init;
    procedure BnHilfeClick(Sender: TObject);
    procedure EMittelwertKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure BnCompilerSearchClick(Sender: TObject);
    procedure BnLinkerSearchClick(Sender: TObject);
  private
    { Private declarations }
    UAbbruch:boolean;
    UAktuelleSeite:integer;
    //szUZelle : string;

  public
    { Public declarations }
  end;

var
  FEinstProg: TFEinstProg;

implementation

{$R *.DFM}


uses basis, fbasis, PythonIDE_bas, PythonIDE_var;


procedure TFEinstProg.FormCreate(Sender: TObject);
begin
  ECompiler.text := '';
  ECompilerParameter.text := '';
  ERun.text := '';
  ERunParameter.text := '';
end;


procedure TFEinstProg.Init;
begin
  UAbbruch := true;


  UAktuelleSeite := 0;
  BnHilfe.HelpContext := 10500+UAktuelleSeite*100;





  (* Default Pfade *)

    (* 0. Seite *)






  ECompiler.text := G_Compiler;
  ECompilerParameter.text := G_CompilerParameter;
  ERunParameter.text := G_RunParameter;



  UAbbruch:=true;
  Showmodal;
end;  // Init


procedure TFEinstProg.BnOkayClick(Sender: TObject);
begin
  UAbbruch := false;
  G_Tag := 'Okay';
  close;
end;

procedure TFEinstProg.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
//var szZOld, szZ:string;
begin
  if UAbbruch then
  begin
    canclose := true;
  end
  else
  begin
    canclose := false;
    UAbbruch:=true;
    
    //  Plausi

    CanClose := true;
    UAbbruch:=false;



       (* Default Pfade *)



    G_Compiler := ECompiler.text;
    G_CompilerParameter := ECompilerParameter.text;
    G_RunParameter := ERunParameter.text;




    speichereKonfiguration;
  end;
end;

procedure TFEinstProg.BnAbbruchClick(Sender: TObject);
begin
  UAbbruch := true;
  close;
end;



procedure TFEinstProg.BnHilfeClick(Sender: TObject);
begin
  Application.HelpCommand( HELP_CONTEXT, 10500+UAktuelleSeite*100 );
end;


procedure TFEinstProg.EMittelwertKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (shift=[]) and (key=13) then BnOkayClick(Sender);
  if (shift=[]) and (key=27) then BnAbbruchClick(Sender);
end;

procedure TFEinstProg.BnCompilerSearchClick(Sender: TObject);
begin
  OpenDialog1.Title := 'Compiler einstellen';
  OpenDialog1.Options :=  [ofEnableSizing, ofPathMustExist,ofShowHelp];
  OpenDialog1.FileName:='*.EXE;*.COM';
  OpenDialog1.InitialDir := copy(G_Pfad,1,1)+':\';
  OpenDialog1.Filter:=  'COM-Dateien *.COM|*.COM|'+
                        'EXE-Dateien *.EXE|*.EXE|'+
                        'Alle Dateien (*.*)|*.*';

  if OpenDialog1.Execute then
  begin
    ECompiler.text  := OpenDialog1.FileName;
  end;
end;

procedure TFEinstProg.BnLinkerSearchClick(Sender: TObject);
begin
  OpenDialog1.Title := 'Compiler einstellen';
  OpenDialog1.Options :=  [ofEnableSizing, ofPathMustExist,ofShowHelp];
  OpenDialog1.FileName:='*.EXE;*.COM';
  OpenDialog1.InitialDir := copy(G_Pfad,1,1)+':\';
  OpenDialog1.Filter:=  'COM-Dateien *.COM|*.COM|'+
                        'EXE-Dateien *.EXE|*.EXE|'+
                        'Alle Dateien (*.*)|*.*';

  if OpenDialog1.Execute then
  begin
    ERun.text  := OpenDialog1.FileName;
  end;
end;




end.




