unit MDIDEdit;  (* Oro *)

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, Buttons, ExtCtrls, ComCtrls, Spin;

const BackupExt = '.BAK';

type pString = ^String;

type
  TFMDIDEdit = class(TForm)
    MainMenu1: TMainMenu;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    PrintDialog1: TPrintDialog;
    MainBearbeiten: TMenuItem;
    MnSpeichern: TMenuItem;
    MnSpeichernUnter: TMenuItem;
    MnBlockAusschneiden: TMenuItem;
    MnBlockKopieren: TMenuItem;
    MnBlockEinfuegen: TMenuItem;
    MnBlockLoeschen: TMenuItem;
    N2: TMenuItem;
    MnAllesmarkieren: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    MainDatei1: TMenuItem;
    MnNeu: TMenuItem;
    MnOeffnen: TMenuItem;
    N4: TMenuItem;
    MnDOSEbene: TMenuItem;
    N6: TMenuItem;
    MnExit: TMenuItem;
    N8: TMenuItem;
    MnInsertFile: TMenuItem;
    N1: TMenuItem;
    MnAktuelleZeileloeschen: TMenuItem;
    MnBlocknachlinks: TMenuItem;
    MnBlocknachrechts: TMenuItem;
    MainSuchen: TMenuItem;
    MnSuchen: TMenuItem;
    MnWeitersuchen: TMenuItem;
    MnSuchenErsetzen: TMenuItem;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    OpenDialog1: TOpenDialog;
    MnKonverttextvonDOSnachWindows: TMenuItem;
    MnKonverttextvonWindowsnachDOS: TMenuItem;
    N3: TMenuItem;
    MnZeilebisEndeLoeschen: TMenuItem;
    MnRueckgaengig: TMenuItem;
    N5: TMenuItem;
    MnGehezu: TMenuItem;
    N14: TMenuItem;
    Timer1: TTimer;
    MnSpeichernAlle: TMenuItem;
    MnBlockalsDateiSichern: TMenuItem;
    SpaltenEdit: TRichEdit;
    N10: TMenuItem;
    MnIncrementielleSuche: TMenuItem;
    StatusBar1: TStatusBar;
    MnAlleSchliessen: TMenuItem;
    MnUpdate: TMenuItem;
    PopupMenu1: TPopupMenu;
    LkRueckgaengig: TMenuItem;
    N31: TMenuItem;
    LkBlockAusschneiden: TMenuItem;
    LkBlockKopieren: TMenuItem;
    LkBlockLoeschen: TMenuItem;
    LkBlockEinfuegen: TMenuItem;
    N33: TMenuItem;
    LkGeheZu: TMenuItem;
    N34: TMenuItem;
    LkAllesmarkieren: TMenuItem;
    N26: TMenuItem;
    LkSuchen: TMenuItem;
    LkWeitersuchen: TMenuItem;
    LkSuchenErsetzen: TMenuItem;
    N37: TMenuItem;
    LkIncrementielleSuche: TMenuItem;
    MainCompilerRun1: TMenuItem;
    MnCompiler: TMenuItem;
    MnRun: TMenuItem;
    MnSetMainD: TMenuItem;
    MnProgrammEinstellungen: TMenuItem;
    MnTaschenrechner: TMenuItem;
    MnExplorer: TMenuItem;
    MnNotepad: TMenuItem;
    N11: TMenuItem;
    MnBuildAllerDateien: TMenuItem;
    MainEinfuegen: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N15: TMenuItem;
    PopupMenu2: TPopupMenu;
    EinfgenneuerDatei1: TMenuItem;
    EinfgenbestehenderDatei1: TMenuItem;
    LschenderaktuellenDatei1: TMenuItem;
    N16: TMenuItem;
    PanelCenter: TPanel;
    PanelFile: TPanel;
    MnInsertMain: TMenuItem;
    Memo1: TMemo;
    procedure MyMessage(var Msg:TMsg; var Handled:boolean);
    procedure WndProc(var Message:TMessage); override;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MnAllesmarkierenClick(Sender: TObject);
    procedure MnBlockKopierenClick(Sender: TObject);
    procedure MnBlockEinfuegenClick(Sender: TObject);
    procedure MnBlockAusschneidenClick(Sender: TObject);
    procedure MnBlockLoeschenClick(Sender: TObject);
    procedure UpdateMenus;
    procedure Open(const AFilename: string);
    procedure MnSpeichernUnterClick(Sender: TObject);
    procedure MnSpeichernClick(Sender: TObject);
    procedure MnDruckenClick(Sender: TObject);
    procedure AddZeile(szZeile:string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MnDruckerSetupClick(Sender: TObject);
    procedure MnInsertFileClick(Sender: TObject);
    procedure MnAktuelleZeileloeschenClick(Sender: TObject);
    procedure MnBlocknachlinksClick(Sender: TObject);
    procedure MnBlocknachrechtsClick(Sender: TObject);
    procedure MnSuchenClick(Sender: TObject);
    procedure MnWeitersuchenClick(Sender: TObject);
    procedure MnSuchenErsetzenClick(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure setzeOpenFilter;
    procedure setzeSaveFilter;
    procedure FormCreate(Sender: TObject);
    procedure MnOeffnenClick(Sender: TObject);
    procedure MnNeuClick(Sender: TObject);
    procedure MnDOSEbeneClick(Sender: TObject);
    procedure MnKonverttextvonDOSnachWindowsClick(Sender: TObject);
    procedure MnKonverttextvonWindowsnachDOSClick(Sender: TObject);
    procedure MnRueckgaengigClick(Sender: TObject);
    procedure MnZeilebisEndeLoeschenClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MnGehezuClick(Sender: TObject);
    procedure MnSpeichernAlleClick(Sender: TObject);
    procedure MnBlockalsDateiSichernClick(Sender: TObject);
    procedure MnIncrementielleSucheClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
    procedure MnAlleSchliessenClick(Sender: TObject);
    procedure FindDialog1Close(Sender: TObject);
    procedure MnUpdateClick(Sender: TObject);
    procedure Memo1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure LkRueckgaengigClick(Sender: TObject);
    procedure LkBlockAusschneidenClick(Sender: TObject);
    procedure LkBlockKopierenClick(Sender: TObject);
    procedure LkBlockLoeschenClick(Sender: TObject);
    procedure LkBlockEinfuegenClick(Sender: TObject);
    procedure LkGeheZuClick(Sender: TObject);
    procedure LkAllesmarkierenClick(Sender: TObject);
    procedure LkSuchenClick(Sender: TObject);
    procedure LkWeitersuchenClick(Sender: TObject);
    procedure LkSuchenErsetzenClick(Sender: TObject);
    procedure LkIncrementielleSucheClick(Sender: TObject);
    procedure MnAktuellerInhaltspeichernClick(Sender: TObject);
    procedure MnCompilerClick(Sender: TObject);
    procedure MnRunClick(Sender: TObject);
    procedure MnProgrammEinstellungenClick(Sender: TObject);
    procedure MnTaschenrechnerClick(Sender: TObject);
    procedure MnExplorerClick(Sender: TObject);
    procedure MnNotepadClick(Sender: TObject);
    procedure MnInsertKlasseClick(Sender: TObject);
    procedure MnIfBedingungMitElseClick(Sender: TObject);
    procedure Test1Click(Sender: TObject);
    procedure MnForLoopClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EinfgenneuerDatei1Click(Sender: TObject);
    procedure EinfgenbestehenderDatei1Click(Sender: TObject);
    procedure LschenderaktuellenDatei1Click(Sender: TObject);
  protected
//    procedure WMKeydown(var Message:TMessage); message WM_KEYDOWN;
  private
    { Private-Deklarationen }
    _Datei, _Pfad, _Name, _Ext:string;

    _Filter:string;                // saveAs
    _Filtermaske:string;

    _ProjectFiles:TList; // pString

    _SpaltenblockVorhanden:boolean;
    _IncSucheUp, _IncSuche:boolean;
    _Startpos:integer;
    _SuchString:string;
    _Startpossi:array[1..500] of integer;
    _AnzStartpossi:integer;

    _LastDatei:string;

    _AnzZeichen:longint;  // Suchen Position  und fr Timer
    _Start:longint;

    _OutputMemo:TMemo;

   procedure AddRow(var i:integer; s:String);
   procedure Suchen(szSuchtext:string; GrossKleinUnterscheidung, SucheNachUnten:boolean);
   function  SuchenUndErsetzen(szSuchtext, szErsetzText:string; GrossKleinUnterscheidung, SucheNachUnten:boolean):boolean;
   procedure leseFilter;
   procedure StartDos(szCommand, szParameter, szDatei:string);
   procedure StartDosOhne(szCommand, szParameter, szDatei:string);
   function  getLine(FromLine:integer; szItem:string):integer;
   function  getNotLine(FromLine:integer; szItem:string):integer;
   function  getLineFromBottom(szItem:string):integer;
    procedure Compile(sParam:string);
    procedure RRun(sExe:string);

  public
    { Public-Deklarationen }
    UNummer:integer;
    procedure Init(filename:string);
    function  getFileName:string;
    procedure SetShortKey;
    function getPath():string;
  end;

var  FMDIDEdit: TFMDIDEdit;

implementation


{$R *.DFM}

uses PythonIDE_var,
     Dbasis,
     Basis,
     FBasis,
     Main,
     //NewDataTyp,
     Printers,
     IncSuche,
     Clipbrd,
     StrUtils,
     EinstProg;


procedure TFMDIDEdit.FormCreate(Sender: TObject);
begin
  PanelCenter.Align := alClient;
  Application.OnMessage := MyMessage;

  Memo1.WantTabs := G_InEditMitTabs;

  _SpaltenblockVorhanden := false;
  SetShortKey;

  _ProjectFiles:=TList.Create()
end;
     
     // bergabe Projekt oder datei
procedure TFMDIDEdit.Init(filename:string);
var sItem, sExt:string;
    kanal:textfile;
    pRec:pString;
begin
  Caption := filename;

  sExt:= Uppercase(ExtractFileExt(filename));

  MnSpeichern.Enabled:=true;
  MnSpeichernUnter.Enabled:=true;

  _Datei := filename;
  fsplit(filename, _Pfad, _Name, _Ext);

  Memo1.Align := alClient;

    if FileExists(filename) then
    begin
      Open(filename);
    end
    else
    begin
      Memo1.Clear;
      _Datei := C_Untitled;
      //if G_CaptionMitVollemNamen
      Caption := _Datei;
      //else Caption := szUName+szUExt;  //  maintab
      Memo1.lines.add('# coding=utf8');
      Memo1.lines.add('');
    end;


  Memo1.Font.Name := G_EditorSchriftName;
  Memo1.Font.Size := G_EditorSchriftGroesse;
  if G_EditorSchriftBold
  then Memo1.Font.Style := [fsBold]
  else Memo1.Font.Style := [];
//  Memo1.Font.Color := G_EditorSchriftFarbe;

    Memo1.Modified:=false;

  show;
end;

procedure TFMDIDEdit.leseFilter;
begin
  _Filter:= 'Python-Dateien (*.py)|Alle Dateien (*.*)|*.*';
  _Filtermaske := '*.d';
end;  // leseFilter



function TFMDIDEdit.getFileName:string;
begin
  result := _Datei;
end;

procedure TFMDIDEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TFMDIDEdit.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var DialogValue: Integer;
    FName: string;
begin
  CanClose:=true;
  if (Memo1.Modified)  then
  begin
    FName := _Datei;
    if FName = C_Untitled
    then DialogValue := MessageDlg( SWarningTextNoname, mtConfirmation,
                           [mbYes, mbNo, mbCancel], 0)

    else DialogValue := MessageDlg(Format(SWarningText, [FName]), mtConfirmation,
      [mbYes, mbNo, mbCancel], 0);

    case DialogValue of
      id_Yes: if FName = C_Untitled
              then MnSpeichernUnterClick(Sender)
              else MnSpeichernClick(Sender);
      id_Cancel: CanClose := False;
    end;
  end;
  FMain.LoescheFensterEintrag(handle);
  _ProjectFiles.Free();
end;



procedure TFMDIDEdit.EinfgenneuerDatei1Click(Sender: TObject);
begin
//
end;

procedure TFMDIDEdit.EinfgenbestehenderDatei1Click(Sender: TObject);
begin
//
end;

procedure TFMDIDEdit.LschenderaktuellenDatei1Click(Sender: TObject);
begin
//
end;


procedure TFMDIDEdit.MnAllesmarkierenClick(Sender: TObject);
begin
  Memo1.SelectAll;
end;

procedure TFMDIDEdit.MnBlockKopierenClick(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

procedure TFMDIDEdit.MnBlockEinfuegenClick(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
  Memo1.Modified:=true;
end;

procedure TFMDIDEdit.MnBlockAusschneidenClick(Sender: TObject);
begin
  Memo1.CutToClipboard;
  Memo1.Modified:=true;
end;

procedure TFMDIDEdit.MnBlockLoeschenClick(Sender: TObject);
begin
  Memo1.ClearSelection;
  Memo1.Modified:=true;
end;

procedure TFMDIDEdit.UpdateMenus;
var HasSelection: Boolean;
begin
  MnBlockEinfuegen.Enabled := Clipboard.HasFormat(CF_TEXT); (* Paste *)
  (* Paste2.Enabled := Clipboard.HasFormat(CF_TEXT); *)
  HasSelection := Memo1.SelLength <> 0;
  MnBlockAusschneiden.Enabled := HasSelection;
  MnBlockKopieren.Enabled := HasSelection;
  MnBlockLoeschen.Enabled := HasSelection;
  MnBlockAlsDateiSichern.enabled := HasSelection;

  (*
  Cut2.Enabled := HasSelection;
  Copy2.Enabled := HasSelection;
  *)
end;


procedure TFMDIDEdit.Open(const AFilename: string);
var s:string;
begin
  if G_EditLength
  then Memo1.MaxLength := getFileSize(AFilename)+40000
  else Memo1.MaxLength := 0;

  Memo1.Lines.LoadFromFile(AFilename);
  //  ersetze Tabs durch 2 Blanks
  s := Memo1.Text;
  // AnsiReplaceText(const AText, AFromText, AToText: string): string;
  s := AnsiReplaceStr(s,#9,'  ');
  Memo1.Text := s;
  Memo1.SelStart := 0;
  //caption := ExtractFileName(szUDatei);
  Memo1.Modified := False;
  FMain.StatusBar1.Panels.Items[1].Text  := '';
end;

procedure TFMDIDEdit.setzeSaveFilter;
begin
  //SaveDialog1.FileName:= szUFiltermaske;
  SaveDialog1.Filter := _Filter;
  SaveDialog1.InitialDir := G_EditorPfad;
end;


procedure TFMDIDEdit.MnSpeichernUnterClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Datei speichern unter';
  SaveDialog1.Filename := _Datei;
  SaveDialog1.DefaultExt := 'py';
  setzeSaveFilter;
  if SaveDialog1.Execute then
  begin
    _Datei := SaveDialog1.Filename;
    fsplit(_Datei, _Pfad, _Name, _Ext);
    Caption := ExtractFileName(_Datei);
    MnSpeichernClick(Sender);
  end;
end;

procedure TFMDIDEdit.MnSpeichernClick(Sender: TObject);
begin
  if (_Datei = '') or (_Datei = C_Untitled) or IsReadOnly(_Datei) then
  begin
    show;
    MnSpeichernUnterClick(Sender);
  end
  else
  begin
    if G_BakDateiErstellen then CreateBackup(_Datei);
    Memo1.Lines.SaveToFile(_Datei);
    Memo1.Modified := False;
    Fmain.StatusBar1.Panels.Items[1].Text  := '';
  end;
end; (* speichern   mit Backup *)

procedure TFMDIDEdit.MnDruckenClick(Sender: TObject);
begin
//  DruckenMemo(szUDatei, Memo1, FMain.MainMemo, true);
end;

procedure TFMDIDEdit.AddZeile(szZeile:string);
begin
  Memo1.Lines.Add(szZeile);
end;







procedure TFMDIDEdit.MnDruckerSetupClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;


procedure TFMDIDEdit.setzeOpenFilter;
begin
  OpenDialog1.FileName:='*.DAT';
  OpenDialog1.Filter:='Text-Dateien *.DAT|*.DAT|Text-Dateien *.TXT|*.TXT|Alle Dateien (*.*)|*.*';
  OpenDialog1.InitialDir := G_EditorPfad;
end;

procedure TFMDIDEdit.MnInsertFileClick(Sender: TObject);
begin
  OpenDialog1.Title := 'Datei in das aktuelle Fenster einfgen';
  setzeOpenFilter;
  OpenDialog1.Options :=  [ofEnableSizing, ofPathMustExist,ofShowHelp];
  (*
  if (szUExt <> '') and (szUExt<>'.DAT') then
  begin
    OpenDialog1.Filter := 'Alte Dateimaske *'+szUExt+'|*'+szUExt+'|'+ OpenDialog1.Filter;
    OpenDialog1.FileName := '*'+szUExt;
  end;
    *)
  if OpenDatei(OpenDialog1) then
  begin
    FMain.MainMemo.Lines.loadfromfile(OpenDialog1.FileName);
    FMain.MainMemo.SelectAll;
    FMain.MainMemo.CopyToClipboard;
    if G_EditLength
    then Memo1.MaxLength := getFileSize(OpenDialog1.FileName)+getFileSize(_Datei)+40000
    else Memo1.MaxLength := 0;

    Memo1.PasteFromClipboard;
    FMain.StatusBar1.Panels.Items[1].Text  := 'gendert';
    Memo1.Modified:=true;
  end;
end;

procedure TFMDIDEdit.MnAktuelleZeileloeschenClick(Sender: TObject);
var Anfang:longint;
begin
  Anfang := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.Selstart,0); //+1;
  Memo1.Lines.Delete(Anfang);
end;

procedure TFMDIDEdit.MnBlocknachlinksClick(Sender: TObject);
var  Sel1, Sel2, Anfang, i, Ende:longint;
     szZ:string;
begin
  Sel1 := Memo1.Selstart;
  Sel2 := Memo1.SelLength;
  Anfang := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.Selstart,0);
  Ende := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.Selstart+Memo1.SelLength,0);
  for i:= Anfang to Ende do
  begin
    szZ := Memo1.Lines[i];
    if copy(szZ,1,1) = ' ' then Memo1.Lines[i] := copy( szZ,2,length(szZ) );
    dec(Sel2,1);
  end;
  Memo1.Selstart := Sel1;
  Memo1.SelLength := Sel2;
end;

procedure TFMDIDEdit.MnBlocknachrechtsClick(Sender: TObject);
var  Sel1, Sel2, Anfang, i, Ende:longint;
begin
  Memo1.visible := false;
  Sel1 := Memo1.Selstart;
  Sel2 := Memo1.SelLength;
  Anfang := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.Selstart,0);
  Ende := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.Selstart+Memo1.SelLength,0);
  for i:= Anfang to Ende do
  begin
    Memo1.Lines[i] := ' '+Memo1.Lines[i];
    inc(Sel2,1);
  end;
  Memo1.Selstart := Sel1;
  Memo1.SelLength := Sel2;
  Memo1.visible := true;
end;






procedure TFMDIDEdit.MnWeitersuchenClick(Sender: TObject);
begin
  FindDialog1Find(FindDialog1);
end;

procedure TFMDIDEdit.MnSuchenErsetzenClick(Sender: TObject);
begin
  ReplaceDialog1.Execute;
end;

procedure TFMDIDEdit.FindDialog1Close(Sender: TObject);
begin
//   Memo1.Update;
end;

{$define t2}
{$ifdef t2}

procedure TFMDIDEdit.MnSuchenClick(Sender: TObject);
var szZ:string;
    n, i:integer;
begin
     // suchen der aktuellen Position und bestimmen des aktuellen Wortes
  if G_SucheAmAktuellenCursor then
  begin
    szZ := '';
    for i:=Memo1.Selstart+1 to length(Memo1.Text)-1 do
    begin
      n := ord(Memo1.text[i]);
      if n IN [9,10,13, 32..47]
      then break
      else szZ := szZ + Memo1.text[i];
    end;
    if length(szZ) > 0 then
    begin
      FindDialog1.FindText := szZ;
    end;
  end;
  // FindDialog1.Position := Point(Memo1.Left, Memo1.Top);
  if FindDialog1.Execute then  MnWeitersuchen.Enabled := True;
end;


procedure TFMDIDEdit.FindDialog1Find(Sender: TObject);
//var  //FoundAt: LongInt;
     //StartPos, ToEnd: integer;
var GrossKleinUnterscheidung, SucheNachUnten:boolean;
    szSuchtext:string;
begin
  with FindDialog1 do
  begin
    GrossKleinUnterscheidung := frMatchCase in Options;
    SucheNachUnten := frDown in Options;
    szSuchtext := FindText;
  end;
  FindDialog1.CloseDialog;
  Suchen(szSuchtext, GrossKleinUnterscheidung, SucheNachUnten);
end;


{$else}

procedure TFMDIDEdit.MnSuchenClick(Sender: TObject);
var szZ:string;
    n, i:integer;
begin
     // suchen der aktuellen Position und bestimmen des aktuellen Wortes
  if G_SucheAmAktuellenCursor then
  begin
    szZ := '';
    for i:=Memo1.Selstart+1 to length(Memo1.Text)-1 do
    begin
      n := ord(Memo1.text[i]);
      if n IN [9,10,13, 32..47]
      then break
      else szZ := szZ + Memo1.text[i];
    end;
    if length(szZ) > 0 then
    begin
      FindDialog1.FindText := szZ;
    end;
  end;
  // FindDialog1.Position := Point(Memo1.Left, Memo1.Top);
  if FindDialog1.Execute then  MnWeitersuchen.Enabled := True;
end;


// TRichtextedit  hat Findtext
// TMemo nicht
procedure TFMDIDEdit.FindDialog1Find(Sender: TObject);
var FoundAt: LongInt;
    StartPos, ToEnd: Integer;
    s:string;
begin
(*
  begin
    { Suchbeginn nach der aktuellen Markierung (falls vorhanden), }
    { andernfalls am Textanfang starten }

    if Memo1.SelLength <> 0
    then StartPos := Memo1.SelStart + Memo1.SelLength
    else StartPos := Memo1.SelStart;  // 0

    { ToEnd ist die Lnge von StartPos bis zum Ende des Textes im RTF-Eingabefeld }

    ToEnd := Length(Text) - StartPos;


    //TFindOption = (frDown, frFindNext, frHideMatchCase, frHideWholeWord, frHideUpDown, frMatchCase, frDisableMatchCase, frDisableUpDown, frDisableWholeWord, frReplace, frReplaceAll, frWholeWord, frShowHelp);
    if frMatchCase in FindDialog1.Options
    then  FoundAt := Memo1.FindText(FindDialog1.FindText, StartPos, ToEnd, [stMatchCase])
    else  FoundAt := Memo1.FindText(FindDialog1.FindText, StartPos, ToEnd, []);

    if FoundAt <> -1 then
    begin
      FindDialog1.CloseDialog;
      Memo1.SetFocus;
      Memo1.SelStart := FoundAt;
      Memo1.SelLength := Length(FindDialog1.FindText);
      Memo1.setfocus;

      PostMessage( Memo1.Handle, WM_KEYDOWN, VK_LEFT, 0 );  // 10
      PostMessage( Memo1.Handle, WM_KEYDOWN, VK_RIGHT, 0 );  // 10

      Timer1.Enabled:=true;  // gefundene Wort selektieren
    end;
  end;
*)  
end;
{$endif}

(*
var GrossKleinUnterscheidung, SucheNachUnten:boolean;
    szSuchtext:string;
begin
 with FindDialog1 do
  begin
    GrossKleinUnterscheidung := frMatchCase in Options;
    SucheNachUnten := frDown in Options;
    szSuchtext := FindText;
  end;
  FindDialog1.CloseDialog;
  Suchen(szSuchtext, GrossKleinUnterscheidung, SucheNachUnten);
end;
*)


procedure TFMDIDEdit.Suchen(szSuchtext:string; GrossKleinUnterscheidung, SucheNachUnten:boolean);
var  K1, K, N, I: Integer;
     C:Char;
     CharMap: array [Char] of Char;
var Buffer: PChar;
    Size: integer;
begin
  if GrossKleinUnterscheidung
  then szSuchtext:=szSuchtext
  else szSuchtext:=AnsiUppercase(szSuchtext);
  n := length(szSuchtext);
  { Using a Char map array is faster than calling AnsiUpper on every character }
  for C := Low(CharMap) to High(CharMap) do
    CharMap[C] := C;

  if not GrossKleinUnterscheidung then
  begin
    AnsiUpperBuff(PChar(@CharMap), sizeof(CharMap));
    (* AnsiUpperBuff(@SearchString[1], Length(SearchString)); *)
  end;


  Size := Memo1.GetTextLen;      { Lnge des Strings in Edit1 holen }
  Inc(Size);                     { Platz fr Nullzeichen schaffen }
  GetMem(Buffer, Size);          { dynamische Puffervariable erzeugen }
  Memo1.GetTextBuf(Buffer,Size); { Edit1.Text in den Puffer setzen }

  k1 := Memo1.SelStart;
  if k1 < 0 then k1 := 0;
  if SucheNachUnten then
  begin
    For I := k1+1 to Size-1 do
    begin
      K := 0;
      while (CharMap[Buffer[i+k]] = szSuchtext[k+1]) do
      begin
        Inc(k);
        if k >= n then
        begin
          // FreeMem(Buffer, Size);         { fr den Puffer reservierten Speicher freigeben }
          Memo1.SetFocus;
          memo1.SelStart := i;

          Memo1.SelLength := n;
          Exit;
        end;
      end;
    end; (* for Zeilen *)
  end
  else
  begin
    For I := k1-1 downto 0 do
    begin
      K := 0;
      while (CharMap[Buffer[i+k]] = szSuchtext[k+1]) do
      begin
        Inc(k);
        if k >= n then
        begin
          FreeMem(Buffer, Size);         { fr den Puffer reservierten Speicher freigeben }
          Memo1.SetFocus;
          Memo1.SelStart := i;

          Memo1.SelLength := n;
          Exit;
        end;
      end;
    end; (* for Zeilen *)
  end;

  FreeMem(Buffer, Size);         { fr den Puffer reservierten Speicher freigeben }
  Meldung('Suchen','Der Suchstring'+NL+  szSuchtext+NL+'konnte nicht gefunden werden');
end;


procedure TFMDIDEdit.ReplaceDialog1Find(Sender: TObject);
var GrossKleinUnterscheidung, SucheNachUnten:boolean;
    szErsetzText, szSuchtext:string;
begin(*   monochrome  *)
   (* wird aufgerufen, wenn  im suchen/ersetze "suchen"  angeklickt wird *)
 with ReplaceDialog1 do                 (* wird nicht aufgerufen *)
  begin
    GrossKleinUnterscheidung := frMatchCase in Options;
    SucheNachUnten := frDown in Options;
    szSuchtext := FindText;
    szErsetzText := ReplaceText;
  end;
  (*
  ReplaceDialog1.CloseDialog;
  *)
  SuchenUndErsetzen(szSuchtext, szErsetzText, GrossKleinUnterscheidung, SucheNachUnten);
end;

procedure TFMDIDEdit.ReplaceDialog1Replace(Sender: TObject);
var  Found: Boolean;
var GrossKleinUnterscheidung, SucheNachUnten:boolean;
    szErsetzText, szSuchtext:string;
begin
  with ReplaceDialog1 do
  begin
    GrossKleinUnterscheidung := frMatchCase in Options;
    SucheNachUnten := frDown in Options;
    szSuchtext := FindText;
    szErsetzText := ReplaceText;
    if AnsiCompareText(Memo1.SelText, FindText) = 0 then
      Memo1.SelText := ReplaceText;
    Found := SuchenUndErsetzen(szSuchtext, szErsetzText, GrossKleinUnterscheidung, SucheNachUnten);
    while Found and (frReplaceAll in Options) do
    begin
      Memo1.SelText := ReplaceText;
      Found := SuchenUndErsetzen(szSuchtext, szErsetzText, GrossKleinUnterscheidung, SucheNachUnten);
    end;
    if (not Found) and (frReplace in Options) then
      Meldung('Suchen/Ersetzen','Der Suchstring'+NL+ szSuchtext+NL+'konnte nicht gefunden werden');
  end;
end;


function TFMDIDEdit.SuchenUndErsetzen(szSuchtext, szErsetzText:string; GrossKleinUnterscheidung, SucheNachUnten:boolean):boolean;
var  K1, K, N, I: Integer;
     C:Char;
     CharMap: array [Char] of Char;
var Buffer: PChar;
    Size: integer;
begin
  SuchenUndErsetzen := false;
  if GrossKleinUnterscheidung
  then szSuchtext:=szSuchtext
  else szSuchtext:=AnsiUppercase(szSuchtext);
  n := length(szSuchtext);
  { Using a Char map array is faster than calling AnsiUpper on every character }
  for C := Low(CharMap) to High(CharMap) do
    CharMap[C] := C;

  if not GrossKleinUnterscheidung then
  begin
    AnsiUpperBuff(PChar(@CharMap), sizeof(CharMap));
    (* AnsiUpperBuff(@SearchString[1], Length(SearchString)); *)
  end;


  Size := Memo1.GetTextLen;      { Lnge des Strings in Edit1 holen }
  Inc(Size);                     { Platz fr Nullzeichen schaffen }
  GetMem(Buffer, Size);          { dynamische Puffervariable erzeugen }
  Memo1.GetTextBuf(Buffer,Size); { Edit1.Text in den Puffer setzen }

  k1 := Memo1.SelStart;
  if k1 < 0 then k1 := 0;
  if SucheNachUnten then
  begin
    For I := k1+1 to Size-1 do
    begin
      K := 0;
      while (CharMap[Buffer[i+k]] = szSuchtext[k+1]) do
      begin
        Inc(k);
        if k >= n then
        begin
          FreeMem(Buffer, Size);         { fr den Puffer reservierten Speicher freigeben }
          Memo1.SetFocus;
          Memo1.SelStart := i;

          Memo1.SelLength := n;
          Exit;
        end;
      end;
    end; (* for Zeilen *)
  end
  else
  begin
    For I := k1-1 downto 0 do
    begin
      K := 0;
      while (CharMap[Buffer[i+k]] = szSuchtext[k+1]) do
      begin
        Inc(k);
        if k >= n then
        begin
          FreeMem(Buffer, Size);         { fr den Puffer reservierten Speicher freigeben }
          Memo1.SetFocus;
          Memo1.SelStart := i;

          Memo1.SelLength := n;
          Exit;
        end;
      end;
    end; (* for Zeilen *)
  end;

  FreeMem(Buffer, Size);         { fr den Puffer reservierten Speicher freigeben }
  Meldung('Suchen','Der Suchstring'+NL+ szSuchtext+NL+'konnte nicht gefunden werden');
end;




procedure TFMDIDEdit.FormActivate(Sender: TObject);
begin
  FMain.setzeFensterHandle(Handle,_Datei, Memo1.Modified);
end;



procedure TFMDIDEdit.SetShortKey;
begin
  MnCompiler.ShortCut := TextToShortCut(  G_KeyCompiler  );
  MnRun.ShortCut := TextToShortCut(  G_KeyRun  );
end;

procedure TFMDIDEdit.MnOeffnenClick(Sender: TObject);
begin
  FMain.MnOeffnenClick(Sender);
end;

procedure TFMDIDEdit.MnNeuClick(Sender: TObject);
begin
  FMain.MnNeuClick(Sender);
end;

procedure TFMDIDEdit.MnDOSEbeneClick(Sender: TObject);
begin
  FMain.MnDOSEbeneClick(Sender);
end;
procedure TFMDIDEdit.MnTaschenrechnerClick(Sender: TObject);
begin
  FMain.MnTaschenrechnerClick(Sender);
end;

procedure TFMDIDEdit.MnExplorerClick(Sender: TObject);
begin
  FMain.MnExplorerClick(Sender);
end;

procedure TFMDIDEdit.MnNotepadClick(Sender: TObject);
begin
  FMain.MnNotepadClick(Sender);
end;

procedure TFMDIDEdit.MnKonverttextvonDOSnachWindowsClick(Sender: TObject);
var s1, s2:string;
begin
  s1 := Memo1.Text;
  if Length(s1) > 0 then
  begin
    SetLength(s2, Length(s1));
    OemToChar( PChar(s1), PChar(s2));
    Memo1.Text := s2;
  end;
end;

procedure TFMDIDEdit.MnKonverttextvonWindowsnachDOSClick(Sender: TObject);
var s1, s2:string;
begin
  s1 := Memo1.Text;
  if Length(s1) > 0 then
  begin
    SetLength(s2, Length(s1));
    CharToOem( PChar(s1), PChar(s2));
    Memo1.Text := s2;
  end;
end;

procedure TFMDIDEdit.MnRueckgaengigClick(Sender: TObject);
begin
  Memo1.Undo;
end;

procedure TFMDIDEdit.MnZeilebisEndeLoeschenClick(Sender: TObject);
var StartPosition, i, n, Anfang:longint;
    szZ :string;
begin
  Anfang := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.Selstart,0);
  if Memo1.Selstart>0 then
  begin
    szZ := Memo1.Lines[Anfang];           // Aktuelle Zeile
    for i:=Memo1.Selstart downto 0 do
    begin
      n := ord(Memo1.text[i]);
      if n = 10 then  // #13    #10
      begin
        StartPosition := Memo1.Selstart - i+1;   // i steht auf #10
            //   UMemo.Selstart  steht auf einen Buchstaben VOR dem Buchstaben
        delete (szZ, StartPosition, length(szZ) );
        Memo1.Lines[Anfang] := szZ;
        exit;
      end;
    end;
  end;
end;  // MnZeilebisEndeLoeschen



procedure TFMDIDEdit.MnGehezuClick(Sender: TObject);
var szZ:string;
    i, n, zeile:integer;
begin
  szZ := Liesc('gewnschte Zeile','Gehe Zu','');
  if szZ <> '' then
  begin
    if IVal(szZ,zeile) then
    begin
      if zeile < Memo1.Lines.Count then
      begin
        n:=0;
        for i:=0 to zeile-2 do
        begin
          n := n + length(Memo1.Lines[i])+2;
        end;
        Memo1.Selstart := n;
        memo1.SelLength := 1;
      end;
    end;
  end;
end;

procedure TFMDIDEdit.MnSpeichernAlleClick(Sender: TObject);
begin
  FMain.SpeichernAlleMDIFenster;
end;



procedure TFMDIDEdit.MnBlockalsDateiSichernClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Block speichern unter';
  SaveDialog1.Filename := '';
  if SaveDialog1.Execute then
  begin
    Memo1.CopyToClipboard;
    FMain.MainMemo.clear;
    FMain.MainMemo.PasteFromClipboard;
    FMain.MainMemo.lines.SaveToFile(SaveDialog1.Filename);
  end;
end;



procedure TFMDIDEdit.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  Memo1.SelStart := _Start;
  Memo1.Sellength:=_AnzZeichen;
end;

procedure TFMDIDEdit.WndProc(var Message:TMessage);
begin
  {$T-}
  case Message.Msg of
    WM_MYCompile: MnCompilerClick(Self);
    WM_MYRun: MnRunClick(Self);
    (*
    WM_Search : begin
                  caption := IntToStr(Message.LParam);
                  Memo1.SelStart := Message.LParam+4;
                  Memo1.Sellength:=1;
                end;
    WM_SearchEnde:
                begin
                  MnIncrementielleSuche.enabled := true;
                end;
                *)
    WM_MYUndo: MnRueckgaengigClick(self);
    WM_MYPaste: MnBlockEinfuegenClick(self);
    WM_MYCopy:  MnBlockKopierenClick(self);
    WM_MYCut:   MnBlockAusschneidenClick(self);
    WM_MYCLOSEALL: begin
                     close;
                   end;

    WM_MYSAVE     : begin
                     MnSpeichernClick(self);
                   end;
    WM_MYPRINT   : begin
                     MnDruckenClick(self);
                   end;
    WM_MYClose   : begin
                      close;
                   end;

    WM_MYSAVEFILE: MnSpeichernClick(@self);
    WM_MYCLOSEWINDOWS: close;
    WM_MYSAVEFILEAS : MnSpeichernUnterClick(@self);
    // WM_MYRueckgaengigDesLoeschens:MnRueckgaengigDesLoeschensClick(@self);
  end;
  inherited WndProc(Message);
  {$T+}
end;


procedure TFMDIDEdit.MnIncrementielleSucheClick(Sender: TObject);
begin
  _Startpos:=Memo1.SelStart;
  _SuchString:='';
  StatusBar1.visible := true;
  StatusBar1.Panels.Items[0].Text  := 'Suchen nach';
  StatusBar1.Panels.Items[1].Text  := '';
  StatusBar1.Panels.Items[2].Text  := 'Ende mit ESC';
  // StatusBar1.update;
  (*
  for i:=1 to 0 do
  begin
    sleep(100);
    StatusBar1.Panels.Items[0].Text  := '';
    StatusBar1.Panels.Items[1].Text  := '';
    StatusBar1.Panels.Items[2].Text  := '';
    sleep(100);
    StatusBar1.Panels.Items[0].Text  := 'Suchen nach';
    StatusBar1.Panels.Items[1].Text  := '';
    StatusBar1.Panels.Items[2].Text  := 'Ende mit ESC';
  end;
  *)
  _IncSuche := false;
  _IncSucheUp:=false;
  _Startpossi[1] := Memo1.SelStart;
  _AnzStartpossi:=1;
  memo1.refresh;
  ton(1);
end;

procedure TFMDIDEdit.MyMessage(var Msg:TMsg; var Handled:boolean);
var key:word;
{$ifdef debug}
var i1,i2,i3, i:integer;
{$endif}
begin
  try
      (*
    case Msg.Message of
      WM_KeyDown: Caption := 'dn- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
      WM_KEYUP: Caption := 'up- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
      WM_CHAR: begin
                 Caption := 'ch- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
               end;
       WM_DEADCHAR: Caption := 'dead- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
       WM_SYSKEYDOWN: Caption := 'sysdn- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
       WM_SYSKEYUP: Caption := 'sysup- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
       WM_SYSCHAR: Caption := 'sysch- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
       WM_SYSDEADCHAR: Caption := 'sysdeadch- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
       WM_KEYLAST: Caption := 'last- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
    end;
    exit;
    *)
    case Msg.Message of
      WM_KeyDown:  begin
                  {$ifdef debug}
                 Labelkeydown.Caption := 'keydn- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.time)+' ';
                   i:= Msg.lparam;
                   i1 := i and $FFFF;
                   i2 := (i shr 16) and $FF;
                   i3 := (i shr 24) and 1;
                 Lkeydownstatus.Caption :=
                     'repeat:'+IntToStr(i1)+' scan'+IntToStr(i2)+'  alt'+IntToStr(i3)+' ';
                  {$endif}
                    (*  auskommentiert 02.06.2007
                      if bUIncSuche and (Msg.wparam=8) then
                      begin
                        Msg.wparam:=0;
                        Msg.message:=0;
                      end;
                      if (bUIncSuche or bUIncSucheUp) and (i3>0) then
                      begin
                        bUIncSuche := false;
                        bUIncSucheUp:=false;
                        StatusBar1.visible := false;
                        bUIncSuche := false;
                        Msg.wparam:=0;
                        Msg.message:=0;
                      end;
                      *)
                    end;
      WM_KEYUP:  begin
                  {$ifdef debug}
                 LabelkeyUp.Caption := 'Keyup- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.time)+' ';
                  {$endif}
                  // ErrorErrorError
                   (*  // entfernt am 28.05.2007
                   if (bUIncSuche or bUIncSucheUp) and (Msg.wparam=8)  then
                   begin
                     if UAnzStartpossi>2 then
                     begin
                       Memo1.Sellength:=0;
                       setlength(szUSuchString, length(szUSuchString)-1);
                       // szUSuchString:= copy(szUSuchString,1, length(szUSuchString)-1);
                       StatusBar1.Panels.Items[1].Text  := szUSuchString;
                       dec(UAnzStartpossi,1);
                       UStartpos := UStartpossi[UAnzStartpossi];
                       Memo1.SelStart  := UStartpossi[UAnzStartpossi];
                       Memo1.Sellength := length(szUSuchString);
                       Handled := false;
                     end;
                     Msg.wparam:=0;
                     Msg.message:=0;
                     // bUIncSuche := false;
                     // bUIncSucheUp := false;
                   end;
                   *)
                 end;

     {$ifdef debug}
       WM_DEADCHAR:  begin
                 Labeldeadchar.Caption := 'deadChar- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
                 end;
       WM_SYSKEYDOWN:  begin
                 //Caption := 'sysKeydn- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
                 end;
       WM_SYSKEYUP:  begin
                 //Caption := 'sysKeyup- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
                 end;
       WM_SYSCHAR:  begin
                 //Caption := 'syschar- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
                 end;
       WM_SYSDEADCHAR:  begin
                 //Caption := 'sysdeadchar- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
                 end;
       WM_KEYLAST:  begin
                 Labelkeylast.Caption := 'keylast- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.lparam)+' ';
                 end;
      {$endif}


      WM_CHAR: begin
                  {$ifdef debug}
              //Caption := 'ch- '+IntTostr(Msg.wparam)+' ' + IntTostr(Msg.time)+' ';
                  {$endif}
             if _IncSuche then
             begin
               key := Msg.wParam;
               if key = 27 then
               begin
                 _IncSuche := false;
                 StatusBar1.visible := false;
                 Msg.wparam:=0;
                 Msg.message:=0;
                 exit;
               end;
               if key < 32 then
               begin
                 if key = 8 then   //
                 begin
                   if _AnzStartpossi>2 then
                   begin
                     Memo1.Sellength:=0;
                     setlength(_SuchString, length(_SuchString)-1);
                     // szUSuchString:= copy(szUSuchString,1, length(szUSuchString)-1);
                     StatusBar1.Panels.Items[1].Text  := _SuchString;
                     dec(_AnzStartpossi,1);
                     _Startpos := _Startpossi[_AnzStartpossi];
                     Memo1.SelStart  := _Startpossi[_AnzStartpossi];
                     Memo1.Sellength := length(_SuchString);
                     Handled := false;
                   end;
                   Msg.wparam:=0;
                   Msg.message:=0;
                   exit;
                 end
                 else
                 begin
                   _IncSuche := false;
                   StatusBar1.visible := false;
                 end;
               end
               else
               begin
                 Msg.wparam:=0;
                 Msg.message:=0;
                 exit;
               end;
             end;

         end;
    end;
  except
    //Meldung('error','Suche1');
  end;
  // Caption := IntTostr(Msg.message);
end;

procedure TFMDIDEdit.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var i:integer;
begin
//  Caption := Caption +' y'+IntToStr(key);
  if key=9 then
  begin
  //  Caption := Caption +'y';
    i := SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0)+1;  // 1 -> n
    AddRow(i,'  ');
    key:=0;
  end;
end;

procedure TFMDIDEdit.FormKeyPress(Sender: TObject; var Key: Char);
begin
//  Caption := Caption +' z'+IntToStr(ord(key));
end;

procedure TFMDIDEdit.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var i:integer;
begin
//  Caption := Caption +' x'+IntToStr(key);
  if _IncSuche then
  begin
    if shift <> [] then
    begin
      _IncSuche := false;
      StatusBar1.visible := false;
    end;
  end
  else
  begin
    if key=9 then
    begin
      //Caption := Caption +'x';
      i := SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0)+1;  // 1 -> n
      AddRow(i,'  ');
      key:=0;
    end;
     //if key=18 then key:=32;
     //if key=9 then key:=32;
  end;
end;

procedure TFMDIDEdit.MnAlleSchliessenClick(Sender: TObject);
begin
 FMain.AlleFensterSchliessen;
end;


procedure TFMDIDEdit.MnUpdateClick(Sender: TObject);
begin
  Memo1.Lines.LoadFromFile(_Datei);
  Memo1.SelStart := 0;
  Memo1.Modified := False;
  FMain.StatusBar1.Panels.Items[1].Text  := '';
end;

procedure TFMDIDEdit.Memo1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var zeilennr:longint;
begin
  zeilennr := SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0)+1;
  FMain.StatusBar1.Panels.Items[0].Text  :=  'Zeile: '+IntToStr(zeilennr);
end;


procedure TFMDIDEdit.LkRueckgaengigClick(Sender: TObject);
begin
  MnRueckgaengigClick(Sender);
end;

procedure TFMDIDEdit.LkBlockAusschneidenClick(Sender: TObject);
begin
  MnBlockAusschneidenClick(Sender);
end;

procedure TFMDIDEdit.LkBlockKopierenClick(Sender: TObject);
begin
  MnBlockKopierenClick(Sender);
end;

procedure TFMDIDEdit.LkBlockLoeschenClick(Sender: TObject);
begin
  MnBlockLoeschenClick(Sender);
end;

procedure TFMDIDEdit.LkBlockEinfuegenClick(Sender: TObject);
begin
  MnBlockEinfuegenClick(Sender);
end;

procedure TFMDIDEdit.LkGeheZuClick(Sender: TObject);
begin
  MnGehezuClick(Sender);
end;

procedure TFMDIDEdit.LkAllesmarkierenClick(Sender: TObject);
begin
  MnAllesmarkierenClick(Sender);
end;

procedure TFMDIDEdit.LkSuchenClick(Sender: TObject);
begin
  MnSuchenClick(Sender);
end;

procedure TFMDIDEdit.LkWeitersuchenClick(Sender: TObject);
begin
  MnWeitersuchenClick(Sender);
end;

procedure TFMDIDEdit.LkSuchenErsetzenClick(Sender: TObject);
begin
  MnSuchenErsetzenClick(Sender);
end;

procedure TFMDIDEdit.LkIncrementielleSucheClick(Sender: TObject);
begin
  MnIncrementielleSucheClick(Sender);
end;

procedure TFMDIDEdit.MnAktuellerInhaltspeichernClick(Sender: TObject);
begin
  Memo1.Lines.SavetoFile(G_Pfad+G_LastVersion);
  _LastDatei := ExtractFileName(_Datei);
  Write_IniString(G_CONFIGFILE,'Version','LastDatei',_LastDatei);
end;


procedure TFMDIDEdit.MnCompilerClick(Sender: TObject);
begin
  if _Datei = C_Untitled then
  begin
    Meldung('Hinweis','Bitte die Datei erst speichern');
    exit;
  end;
  _OutputMemo.Clear();
  Compile('-c');
end;

procedure TFMDIDEdit.MnRunClick(Sender: TObject);
var TimeOBJ:integer;
    TimeD:integer;
    sProgExe:string;
begin
  if _Datei = C_Untitled then
  begin
    Meldung('Hinweis','Bitte die Datei erst speichern');
    exit;
  end;
    TimeD := GetFileTime(_Datei);
    TimeObj :=GetFileTime( _Pfad+_Name+'obj');
    _OutputMemo.Clear();
    if TimeD>TimeObj then
    begin
      Compile('');  // '-c'
    end;
    sProgExe := _Pfad+_Name+'.EXE';
    RRun(sProgExe);
end;

procedure TFMDIDEdit.RRun(sExe:string);
var sObj:string;
begin
  sObj := _Pfad+_Name+'.OBJ';
  if Memo1.Modified then
  begin
    Compile('');  // statt '-c'  ?????????
  end;
  if FileExists(sObj) then
  begin
   StartDosOhne(sExe, G_RunParameter, '');
  end;
end;


// sParam='' oder sParam=-c
procedure TFMDIDEdit.Compile(sParam:string);
begin
  if Memo1.Modified then
  begin
    Memo1.Lines.SaveToFile(_Datei);
  end;
  _OutputMemo.Clear();
  _OutputMemo.lines.add('Compilerstart:');
  StartDos(G_Compiler, G_CompilerParameter+sParam, _Name+_Ext);
end;


function TFMDIDEdit.getPath():string;
begin
  if _Datei = C_Untitled
  then result := ''
  else result := _Pfad;
end;

procedure TFMDIDEdit.MnProgrammEinstellungenClick(Sender: TObject);
var f:TFEinstProg;
begin
  f:=TFEinstProg.create(Application);
  try
    G_Tag:='';
    f.hide;
    f.Init;
  finally
    f.free;
  end;
end;

procedure TFMDIDEdit.StartDosOhne(szCommand, szParameter, szDatei:string);
var   AktPfad:string;
begin
  AktPfad := ExtractFilepath(_Datei);

  if ExecuteFile(szCommand, szParameter, AktPfad, SW_Show)<=32 then
  begin
     Fehler('Fehler','Fehler beim Aufruf des externen Programms');
  end;
end;  // Ohne Umleitung





procedure TFMDIDEdit.StartDos(szCommand, szParameter, szDatei:string);
const CaptureBufferSize = 20000;
var   SecAttrib           : TSecurityAttributes;
      ReadPipe            : THandle;
      WritePipe           : THandle;
      StartupInfo         : TStartUpInfo;
      ProcessInfo         : TProcessInformation;
      CaptureBuffer       : Pchar;
      BytesRead           : DWord;
      BytesWrite          : DWord;
      AnzWrite            : DWord;
      WaitHandle          : DWord;
      AktPfad, s:string;
      s1, s2:PChar;
      bOk:longBool;
begin
  AktPfad := ExtractFilepath(_Datei);

  //UOutPutMemo.Lines.clear;  // ????????
  _OutPutMemo.Update;
  _OutputMemo.lines.add('Datei "'+_Datei+'"');
  _OutputMemo.lines.add('');
  s := _OutputMemo.Text;

  With SecAttrib do
  begin
    nlength              := SizeOf(TSecurityAttributes);
    binherithandle       := true;
    lpsecuritydescriptor := nil;
  end;

  if Createpipe (ReadPipe, WritePipe, @SecAttrib, 0) then
  begin
    if ReadPipe=0 then
    begin
      Fehler('Fehler','ReadPipe konnte nicht erzeugt werden');
    end;
    if WritePipe=0 then
    begin
      Fehler('Fehler','WritePipe konnte nicht erzeugt werden');
    end;

    CaptureBuffer  := AllocMem(CaptureBufferSize + 1);
    FillChar(StartupInfo,Sizeof(StartupInfo),#0);
    StartupInfo.cb          := SizeOf(StartupInfo);
    StartupInfo.hStdOutput  := WritePipe;
    StartupInfo.hStdInput   := ReadPipe;
    StartupInfo.hStdError  := WritePipe;
       //                       Use Standard Hanlde    Uses Show Windows
    StartupInfo.dwFlags     := STARTF_USESTDHANDLES or STARTF_USESHOWWINDOW;
    StartupInfo.wShowWindow := SW_HIDE;


    s1 := nil;
    if szParameter=''
    then  s2 := PChar(szCommand+' '+szDatei)
    else s2 := PChar(szCommand+' '+szParameter+' '+szDatei);

    CaptureBuffer[0] := #13;
    CaptureBuffer[1] := #10;
    BytesWrite:=2;
    WriteFile(WritePipe,CaptureBuffer[0],BytesWrite, AnzWrite,nil);

    //PATH=C:\WINDOWS\system32;C:\WINDOWS;C:\Daten\D;C:\Daten\D;C:\Daten\D\dm\bin\;C:\Daten\D\dmd\bin\;
    if CreateProcess( s1,
        s2,
      @SecAttrib,
      @SecAttrib,
      true,
      CREATE_NEW_CONSOLE + NORMAL_PRIORITY_CLASS,  // creation flag    IDLE_PRIORITY_CLASS  REALTIME_PRIORITY_CLASS   HIGH_PRIORITY_CLASS
      nil,                 // Environment   Path=C:\daten\d
      PChar(AktPfad),       // Verz
      StartupInfo,
      ProcessInfo) then
    begin
      WaitHandle := WAIT_ABANDONED; // 128
      WaitHandle := WAIT_OBJECT_0;    // 0
      if true then
      begin
        repeat
          WaitHandle := WaitForSingleObject( ProcessInfo.hProcess,100);  // 100 ms
          Application.ProcessMessages;
          // Caption := 'WaitHandle: '+IntToStr(WaitHandle);
        until (WaitHandle <> WAIT_TIMEOUT)  or   //    258
              (WaitHandle=WAIT_OBJECT_0) or      //    0
              (WaitHandle=WAIT_FAILED) or        //    4294967295
              application.terminated;
      end
      else
      begin
        WaitHandle := WaitForSingleObject( ProcessInfo.hProcess,Infinite);
      end;
      // Caption := 'Result Waithandle: '+IntToStr(WaitHandle);


      // if (not application.terminated) and (WaitHandle <> WAIT_FAILED) then
      if  (WaitHandle <> WAIT_FAILED) then
      begin
        // s := '';
        // OutputMemo.Clear();
        Repeat
          BytesRead := 0;
                            // D  Absturz
          bOk := ReadFile(ReadPipe,CaptureBuffer[0],CaptureBufferSize,BytesRead,nil);
          if bOk then
          begin
            CaptureBuffer[BytesRead]:= #0;
            OemToAnsi(CaptureBuffer,CaptureBuffer);
            //s := s + String(CaptureBuffer);
            s := String(CaptureBuffer);
            _OutputMemo.lines.add(s);
          end
          else
          begin
            break;
          end;
        until BytesRead < CaptureBufferSize;
        // OutputMemo.Text := s;
        _OutputMemo.lines.add('-- Fertig --');
      end
      else
      begin
        _OutPutMemo.lines.add('Operation wurde abgebrochen!');
      end;
      FreeMem(CaptureBuffer);
      CloseHandle(ProcessInfo.hProcess);
      CloseHandle(ProcessInfo.hThread);
      CloseHandle(ReadPipe);
      CloseHandle(writePipe);
    end
    else  // if CreateProcess(nil,
    begin
      _OutPutMemo.lines.add('Konnte Kommando nicht starten, Fehler: #'+ inttostr(getlasterror));
    end;
  end
  else
  begin
    _OutPutMemo.lines.add('Konnte die Pipes nicht erzeugen');
  end;
  sleeP(300);

end;  // Mit Umleitung



procedure TFMDIDEdit.AddRow(var i:integer; s:String);
begin
  Memo1.Lines.insert(i,s);
  inc(i,1);
end;

procedure TFMDIDEdit.MnInsertKlasseClick(Sender: TObject);
var sClass:string;
    I:integer;
begin
  sClass := liesc('Klassenamen','neue Klasse','test');
  if sClass='' then exit;
  sClass := trim(sClass);
  i := SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0)+1;  // 1 -> n

  AddRow(i,'//  Titel:        Testprogramm');
  AddRow(i,'//  Version:      1.0');
  AddRow(i,'//  Copyright:    Copyright (c) 2007');
  AddRow(i,'//  Autor:        Ihr Name');
  AddRow(i,'//  Firma:        Ihre Organisation');
  AddRow(i,'//  Beschreibung: Ihre Beschreibung');
  AddRow(i,'');
  AddRow(i,'class myClass {');
  AddRow(i,'');
  AddRow(i,'  private');
  AddRow(i,'    int _a;  // private');
  AddRow(i,'');
  AddRow(i,'    // declare constructor for Foo');
  AddRow(i,'    this(int x) {');
  AddRow(i,'      _a=x;');
  AddRow(i,'    }');
  AddRow(i,'');
  AddRow(i,'    this()  {');
  AddRow(i,'      //...');
  AddRow(i,'      _a=2;');
  AddRow(i,'    }');
  AddRow(i,'');
  AddRow(i,'  public');
  AddRow(i,'    int getA() {');
  AddRow(i,'      return _a;');
  AddRow(i,'    }');
  AddRow(i,'');
  AddRow(i,'}  // class test');
  AddRow(i,'');

  Memo1.Modified:=true;
end;

function TFMDIDEdit.getLine(FromLine:integer; szItem:string):integer;
var i:integer;
    s:string;
begin
  for i:=FromLine to Memo1.lines.count do
  begin
    s := Memo1.Lines[i-1];
    if pos(szItem,s)>0 then
    begin
      result := i;
      exit;
    end;
  end;
  result := -1;
end;

function TFMDIDEdit.getNotLine(FromLine:integer; szItem:string):integer;
var i:integer;
    s:string;
begin
  for i:=FromLine to Memo1.lines.count do
  begin
    s := Memo1.Lines[i-1];
    if pos(szItem,s)=0 then
    begin
      result := i;
      exit;
    end;
  end;
  result := -1;
end;

function TFMDIDEdit.getLineFromBottom(szItem:string):integer;
var i:integer;
    s:string;
begin
  for i:=Memo1.lines.count downto 1 do
  begin
    s := Memo1.Lines[i-1];
    if pos(szItem,s)>0 then
    begin
      result := i;
      exit;
    end;
  end;
  result := -1;
end;



procedure TFMDIDEdit.MnIfBedingungMitElseClick(Sender: TObject);
var i:longint;
begin
  i := SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0)+1;  // 1 -> n
  AddRow(i,  '  if () {' );
  AddRow(i,'  }' );
  AddRow(i,'  else {' );
  AddRow(i,'  } // if' );
end;

procedure TFMDIDEdit.MnForLoopClick(Sender: TObject);
var i:longint;
begin
  i := SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0)+1;  // 1 -> n
  AddRow(i,  '  for (i=0; i<n; i++) {' );
  AddRow(i,'  }' );
end;

procedure TFMDIDEdit.Memo1KeyUp(Sender: TObject; var Key: Word;  Shift: TShiftState);
var zeilennr:longint;
begin
  zeilennr := SendMessage(Memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0)+1;
  FMain.StatusBar1.Panels.Items[0].Text  :=  'Zeile: '+IntToStr(zeilennr);
  StatusBar1.Panels.Items[0].Text  :=  'Zeile: '+IntToStr(zeilennr);

(*
  getCurremtPosition
    spaltennr := Memo1.SelStart - SendMessage(Handle, EM_LINEINDEX,
             ( SendMessage(Handle, EM_LINEFROMCHAR, Memo1.SelStart, 0)), 0);
  StatusBar1.Panels.Items[1].Text  :=  'Spalte: '+IntToStr(spaltennr);
  FMain.StatusBar1.Panels.Items[1].Text  :=  'Spalte: '+IntToStr(spaltennr);
*)
end;

procedure TFMDIDEdit.Test1Click(Sender: TObject);
begin
  Memo1.SelStart := 3711;
  Memo1.SelLength := 3;
end;




end.

